/* this is a simple test of Leaker's various features */

#include "leaker.h"

class bar
{
public:
    int j;
};

class foo
{
public:
    bar *b;
};


void FreeTest()
{
    int *a = (int *)1, *b;
    bar *mybar;
    
    free(a);
    
    a = (int *)malloc(sizeof(int));
    free(a);
    free(a);
    
    a = (int *)malloc(sizeof(int));
    b = (int *)realloc(a, sizeof(int));
    free(a);
    free(b);
    
    mybar = (bar *)2;
    delete mybar;
    
    mybar = new bar;
    delete mybar;
    delete mybar;
    
    mybar = (bar *)2;
    delete[] mybar;
    
    mybar = new bar[5];
    delete[] mybar;
    delete[] mybar;
}

void OverflowTest()
{
    int *a, *b, i;
    bar *mybar;
    
    a = (int *)calloc(10, sizeof(int));
    
    for(i = 0; i <= 10; i++)
        a[i] = i;
    
    free(a);
    
    a = (int *)malloc(10 * sizeof(int));
    
    for(i = 0; i <= 10; i++)
        a[i] = i;
    
    free(a);
    
    a = (int *)realloc(NULL, sizeof(int) * 5);
    a = (int *)realloc(a, sizeof(int) * 10);
    
    for(i = 0; i <= 10; i++)
        a[i] = i;
    
    free(a);
    
    mybar = new bar;
    mybar[1].j = 0;
    
    delete mybar;
    
    mybar = new bar[10];
    
    for(i = 0; i <= 10; i++)
        mybar[i].j = 0;
    
    delete[] mybar;
}

void MismatchTest()
{
    int *a;
    bar *mybar;
    
    a = (int *)calloc(1, sizeof(int));
    free(a);
    
    a = (int *)calloc(1, sizeof(int));
    delete a;
    
    a = (int *)calloc(1, sizeof(int));
    delete[] a;
    
    a = (int *)malloc(sizeof(int));
    free(a);
    
    a = (int *)malloc(sizeof(int));
    delete a;
    
    a = (int *)malloc(sizeof(int));
    delete[] a;
    
    a = (int *)realloc(NULL, sizeof(int));
    a = (int *)realloc(a, 2*sizeof(int));
    free(a);
    
    a = (int *)realloc(NULL, sizeof(int));
    free(a);
    
    a = (int *)realloc(NULL, sizeof(int));
    delete a;
    
    a = (int *)realloc(NULL, sizeof(int));
    delete[] a;
    
    mybar = new bar;
    free(mybar);
    
    mybar = new bar;
    delete mybar;
    
    mybar = new bar;
    delete[] mybar;
    
    mybar = new bar[2];
    free(mybar);
    
    mybar = new bar[2];
    delete mybar;
    
    mybar = new bar[2];
    delete[] mybar;
}

void LeaksTest()
{
    int *a;
    foo *myfoo, **yourfoo;
    
    a = (int *)malloc(sizeof(int));
    *a = 1;
    
    myfoo = (foo *)malloc(sizeof(foo));
    myfoo->b = (bar *)malloc(sizeof(bar));
    
    free(myfoo);
    
    yourfoo = (foo **)malloc(sizeof(foo *));
    *yourfoo = (foo *)malloc(sizeof(foo));
    (*yourfoo)->b = (bar *)malloc(sizeof(bar));
    
    free((*yourfoo)->b);
    free(*yourfoo);
    free(yourfoo);
    
    a = (int *)calloc(2, sizeof(int));
    *a = 1;
    
    myfoo = (foo *)calloc(2, sizeof(foo));
    myfoo[1].b = (bar *)calloc(2, sizeof(bar));
    
    free(myfoo);
    
    yourfoo = (foo **)calloc(2, sizeof(foo *));
    yourfoo[1] = (foo *)calloc(2, sizeof(foo));
    yourfoo[1][1].b = (bar *)malloc(sizeof(bar));
    
    free(yourfoo[1][1].b);
    free(yourfoo[1]);
    free(yourfoo);
    
    myfoo = (foo *)realloc(NULL, sizeof(foo));
    myfoo = (foo *)realloc(myfoo, sizeof(foo) * 2);
    free(myfoo);
    
    myfoo = (foo *)realloc(NULL, sizeof(foo));
    myfoo->b = (bar *)realloc(NULL, sizeof(bar)*2);
    
    myfoo = (foo *)realloc(myfoo, sizeof(foo) * 2);
    free(myfoo);
    
    yourfoo = (foo **)realloc(NULL, 2*sizeof(foo *));
    yourfoo[1] = (foo *)realloc(NULL, 2*sizeof(foo));
    yourfoo[1][1].b = (bar *)realloc(NULL, 2*sizeof(bar));
    free(yourfoo[1][1].b);
    free(yourfoo[1]);
    free(yourfoo);
    
    myfoo = new foo;
    myfoo->b = new bar;
    delete myfoo;
    
    yourfoo = new foo *;
    yourfoo[0] = new foo;
    yourfoo[0][0].b = new bar;
    delete yourfoo[0][0].b;
    delete yourfoo[0];
    delete yourfoo;
    
    myfoo = new foo[4];
    myfoo->b = new bar[4];
    delete[] myfoo;
    
    yourfoo = new foo *[4];
    yourfoo[2] = new foo[4];
    yourfoo[2][2].b = new bar[5];
    delete[] yourfoo[2][2].b;
    delete[] yourfoo[2];
    delete[] yourfoo;
}

void CorrectnessTest()
{
    int *tmp = (int *)calloc(10, sizeof(int)), i;
    
    for(i = 0; i < 10; i++) tmp[i] = i;
    
    free(tmp);
    
    tmp = (int *)malloc(sizeof(int)*10);
    
    for(i = 0; i < 10; i++) tmp[i] = i;
    free(tmp);
    
    tmp = (int *)realloc(NULL, sizeof(int)*10);
    
    for(i = 0; i < 10; i++) tmp[i] = i;
    free(tmp);
    
    tmp = (int *)malloc(sizeof(int)*4);
    for(i = 0; i < 4; i++) tmp[i] = i;
    
    tmp = (int *)realloc(tmp, sizeof(int)*10);
    
    for(i = 4; i < 10; i++) tmp[i] = i;
    
    for(i = 0; i < 10; i++) assert(tmp[i] == i);
    
    free(tmp);
    
    tmp = (int *)malloc(sizeof(int)*10);
    for(i = 0; i < 10; i++) tmp[i] = i;
    
    tmp = (int *)realloc(tmp, sizeof(int)*4);
    
    for(i = 0; i < 4; i++) assert(tmp[i] == i);
    assert(tmp[4] != 4);
    
    free(tmp);
    
    tmp = new int;
    
    tmp[0] = 7;
    delete tmp;
    
    tmp = new int[10];
    
    for(i = 0; i < 10; i++) tmp[i] = i;
    delete[] tmp;
}

int main(int argc, char *argv[])
{
    FreeTest();
    OverflowTest();
    MismatchTest();
    LeaksTest();
    CorrectnessTest();
    
    return 0;
}
